#include <bits/stdc++.h>

using namespace std;

#define MOD 1000000009LL

int glupa_sigma(vector<int> niz, int k){
    int velicina=niz.size();
    if(k==0){
        int zbir=0;
        for(int i=0;i<velicina;i++){
            zbir+=(niz[i]%MOD);
        }
        return zbir%MOD;
    }
    else{
        int zbir=0;
        int f=k-1;
        for(int i=0;i<velicina;i++){
            vector<int> niz1;
            for(int j=i;j<velicina;j++){
                niz1.push_back(niz[j]);
                zbir+=glupa_sigma(niz1,f);
            }
        }
        return zbir;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,k;
    cin>>n>>k;
    vector<int> niz(n);
    for(int i=0;i<n;i++){
        cin>>niz[i];
    }
    cout<<glupa_sigma(niz,k);
    return 0;
}